import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class Main {

    public static BufferedReader in;

    public static void main(String[] args) throws IOException {

        in = new BufferedReader(new InputStreamReader(System.in));

        while(true){
            String tmp = in.readLine();
            Integer N;
            if(tmp == null)return;
            else {
                N = Integer.parseInt(tmp);
            }

            if(N == 0)System.out.println("1");
            else{
                System.out.println(compute(N));
            }

        }

    }

    public static long compute(int N){
        boolean even;
        int cycle;
        if(N%2 == 0){
            even=true;
            cycle=N/2;
        }
        else{
            even=false;
            cycle=(N+1)/2;
        }

        long midResult = 1;

        for(int i = 1; i<=cycle; i++){
            if(even){
                midResult*=(2*i);
            }else{
                midResult*=(2*i-1);
            }
            midResult=midResult%10010101;
        }

        long result = midResult;

        return result;
    }
}
